-- $Rev: $

function WMS_016.CreateTimer(delay, hook)
  local timer = {}
  timer.counter = 0
  
  function timer.OnUpdate(frame, elapsed)
    timer.counter = timer.counter + elapsed
    if (timer.counter > delay) then
        timer:StopAndExec()
    end
  end
  
  function timer:Start()
    self.counter = 0
    if not self.timerFrame then
        self.timerFrame = CreateFrame("Frame")
        self.timerFrame:SetScript("OnUpdate", timer.OnUpdate)
        self.timerFrame:Show()
    end
  end

  function timer:Stop()
    if self.timerFrame then
        self.timerFrame:UnregisterAllEvents()
        self.timerFrame:Hide()
        self.timerFrame = nil
    end
  end
  
  function timer:StopAndExec()
      timer:Stop()
      pcall(hook)
  end
  
  function timer:IsTimedOut()
    return timer.counter > delay
  end
  
  return timer
end
